/*
 * Copyright 2006 Takahiro Nakamura.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package woolpack.convert;

import java.util.Collection;
import java.util.Map;

import woolpack.fn.Fn;

/**
 * コンテキスト役のキーを残す{@link Fn}です。
 * @author nakamura
 *
 * @param <E>
 */
public class RetainKeys<E extends Exception> implements Fn<Map<?, ?>, Boolean, E> {
	private Collection<?> collection;
	
	public RetainKeys(final Collection<?> collection) {
		this.collection = collection;
	}

	public Boolean exec(final Map<?, ?> c) {
		c.keySet().retainAll(collection);
		return true;
	}

	public Collection<?> getCollection() {
		return collection;
	}
	public void setCollection(final Collection<?> collection) {
		this.collection = collection;
	}
}
